package edu.whs.spin2018.baoapp.views.lobby;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.Timer;
import java.util.TimerTask;

import edu.whs.spin2018.baoapp.R;
import edu.whs.spin2018.baoapp.model.Benutzer;
import edu.whs.spin2018.baoapp.utilities.ViewUtils;


/**
 * DialogFragment, welches eine eingehende Herausforderung anzeigt.
 */
public class HerausforderungEingehendDialog extends HerausforderungsDialog {

    /**
     * Parameter, die dem Fragment von der aufrufenden Aktivität uebergeben wurden.
     */
    private static final String ARG_BENUTZERNAME = "benutzername";
    private static final String ARG_UUID = "uuid";
    private ImageView mHerausforderungIcon;
    private ImageView mAbgelehntAnzeige;
    private ImageView mAngenommenAnzeige;
    private TextView mHerausforderungStatus;
    private Button mBtnAnnehmen;
    private Button mBtnAblehnen;

    private String gegnerName;
    private String gegnerUUID;

    public HerausforderungEingehendDialog() {
        // Benötigter leerer default Konstruktor
    }

    /**
     * Use this factory method to create a new instance of this fragment using the provided
     * parameters.
     *
     * @param benutzername Benutzername des Herausforderers
     * @param uuid         UUID des Herausforderers
     * @return A new instance of fragment HerausforderungEingehendDialog.
     */
    public static HerausforderungEingehendDialog newInstance(String benutzername, String uuid) {
        HerausforderungEingehendDialog fragment = new HerausforderungEingehendDialog();
        Bundle args = new Bundle();
        args.putString(ARG_BENUTZERNAME, benutzername);
        args.putString(ARG_UUID, uuid);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if (getArguments() != null) {
            gegnerName = getArguments().getString(ARG_BENUTZERNAME);
            gegnerUUID = getArguments().getString(ARG_UUID);
        }
    }

    /**
     * Wird statt onCreateDialog verwendet, da das Layout des Dialogs komplett aus einer XML Datei
     * geladen wird.
     */
    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container,
                             @Nullable Bundle savedInstanceState) {
        View v = getLayoutInflater().inflate(R.layout.dialog_herausforderung_eingehend,
                container, false);

        mAbgelehntAnzeige = v.findViewById(R.id.iv_herausforderung_abgelehnt);
        mAngenommenAnzeige = v.findViewById(R.id.iv_herausforderung_angenommen);
        mHerausforderungStatus = v.findViewById(R.id.tv_herausforderung_status);
        mHerausforderungIcon = v.findViewById(R.id.iv_herausforderung_eingehend_standard_icon);

        TextView tvTitel = v.findViewById(R.id.tv_herausforderung_eingehend_label);
        tvTitel.setText(String.format(getString(R.string.einghende_herausforderung_label),
                gegnerName));

        mBtnAnnehmen = v.findViewById(R.id.btn_herausforderung_eingehend_annehmen);
        mBtnAnnehmen.setOnClickListener(view -> {
            zeigeHerausforderungAngenommen();
            super.gibOnActionHappenedListener().onHerausforderungAngenommenClicked(gegnerUUID);
        });
        ViewUtils.setzeSchatten(mBtnAnnehmen);

        mBtnAblehnen = v.findViewById(R.id.btn_herausforderung_eingehend_ablehnen);
        mBtnAblehnen.setOnClickListener(view -> {
            super.gibOnActionHappenedListener().onHerausforderungAblehnenClicked(gegnerUUID);
            dismissAllowingStateLoss();
        });
        ViewUtils.setzeSchatten(mBtnAblehnen);

        Log.d(TAG, "onCreateView: " + mAbgelehntAnzeige + "\n" + mAngenommenAnzeige + "\n" + mHerausforderungIcon);
        return v;
    }

    @Override
    public void zeigeHerausforderungAngenommen() {
        mAbgelehntAnzeige.setVisibility(View.INVISIBLE);
        mHerausforderungIcon.setVisibility(View.INVISIBLE);
        mAngenommenAnzeige.setVisibility(View.VISIBLE);
        mHerausforderungStatus.setVisibility(View.VISIBLE);
        mHerausforderungStatus.setText(R.string.herausforderung_angenommen);
        mBtnAblehnen.setEnabled(false);
        mBtnAblehnen.setClickable(false);
        mBtnAnnehmen.setEnabled(false);
        mBtnAblehnen.setClickable(false);

        new Timer().schedule(new TimerTask() {
            @Override
            public void run() {
                gibOnActionHappenedListener().starteSpieleinstellungen(
                        new Benutzer(gegnerName, gegnerUUID), gegnerUUID);
                dismissAllowingStateLoss();
            }
        }, DIALOG_SCHLIESSEN_VERZOEGERUNG);
    }

    @Override
    public void zeigeHerausforderungBeendet() {
        Log.d(TAG, "zeigeHerausforderungBeendet: " + mHerausforderungIcon);
        mHerausforderungIcon.setVisibility(View.INVISIBLE);
        mAngenommenAnzeige.setVisibility(View.INVISIBLE);
        mAbgelehntAnzeige.setVisibility(View.VISIBLE);
        mHerausforderungStatus.setVisibility(View.VISIBLE);
        mHerausforderungStatus.setText(getString(R.string.herausforderung_wurde_abgebrochen));

        new Timer().schedule(new TimerTask() {
            @Override
            public void run() {
                gibOnActionHappenedListener().onDialogBeendet();
                dismissAllowingStateLoss();
            }
        }, DIALOG_SCHLIESSEN_VERZOEGERUNG);
    }

    @Override
    public String gibGegnerUUID() {
        return gegnerUUID;
    }
}
